---
title: Peer-to-peer communications with WebRTC
slug: Web/Guide/API/WebRTC/Peer-to-peer_communications_with_WebRTC
tags:
  - API
  - Advanced
  - Communication
  - Guide
  - NeedsContent
  - Peer
  - RTCPeerConnection
  - WebRTC
  - WebRTC API
---
<div>{{WebRTCSidebar}}{{draft}}</div>

<p>The <strong>WebRTC API</strong> is designed to allow JavaScript applications to create real-time connections containing audio and video streams as well as data channels for arbitrary data. These connections are created to directly link two users' browsers, without necessarily requiring any intermediary servers which support the WebRTC protocols. WebRTC also leverages the {{domxref("MediaDevices.getUserMedia", "getUserMedia()")}} method to get access to microphone and camera data. <span class="seoSummary">In this article, we'll take a look at how peer-to-peer connections are created and managed using WebRTC and its {{domxref("RTCPeerConnection")}} interface.</span></p>

<p>A high-level description of what happens in an <code>RTCPeerConnection</code> was shown in an <a href="https://hacks.mozilla.org/2013/05/embedding-webrtc-video-chat-right-into-your-website/">Hacks article</a> (see all WebRTC Hacks articles <a href="https://hacks.mozilla.org/category/webrtc/">here</a>):</p>

<p><img alt="Simple pictograph describing the basics of RTCPeerConnection call setup" src="http://blog.mozilla.org/hacks/files/2013/05/webRTC-BasicsOfHowItWorks2.png"></p>

<h2 id="Resources">Resources</h2>

<ul>
 <li>A good tutorial on basic features in WebRTC is at <a href="http://www.html5rocks.com/en/tutorials/webrtc/basics/">HTML5 Rocks</a>.   A collection of basic test pages to support development are at <a href="https://mozilla.github.com/webrtc-landing">webrtc-landing</a>.</li>
 <li>You can make simple person-to-person calls (including to people using Chrome) at <a href="https://apprtc.appspot.com/">apprtc.appspot.com</a>.</li>
 <li>A high-level description of what happens in an <code>RTCPeerConnection</code> was shown in the <a href="https://hacks.mozilla.org/category/webrtc/">Mozilla Hacks</a> blog article <a href="https://hacks.mozilla.org/2013/05/embedding-webrtc-video-chat-right-into-your-website/">Embedding WebRTC video chat</a>.</li>
</ul>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Media Capture")}}</td>
   <td>{{Spec2("Media Capture")}}</td>
   <td>Definition of the <code>getUserMedia</code> API</td>
  </tr>
  <tr>
   <td>{{SpecName("WebRTC 1.0")}}</td>
   <td>{{Spec2("WebRTC 1.0")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>
